//needed for color_sampling and yuv_order
#define MAKERGB(yuv)\
y = ((0xff & *yuv++) - 16);\
u =   (0xff & *yuv++) - 128;\
y1 = ((0xff & *yuv++) - 16);\
v =  (0xff & *yuv++) - 128;\
r = 104635 * v;\
g = -25690 * u + -53294 * v;\
b = 132278 * u;\
y  *= 76310;\
y1 *= 76310;

#if BITSPP == 32
#define WRITERGB(rgb)\
*rgb++ = LIMIT(b+y);\
*rgb++ = LIMIT(g+y);\
*rgb++ = LIMIT(r+y);\
rgb++;\
*rgb++ = LIMIT(b+y1);\
*rgb++ = LIMIT(g+y1);\
*rgb++ = LIMIT(r+y1);\
rgb++;

#elif BITSPP == 24
#define WRITERGB(rgb)\
*rgb++ = LIMIT(b+y);\
*rgb++ = LIMIT(g+y);\
*rgb++ = LIMIT(r+y);\
*rgb++ = LIMIT(b+y1);\
*rgb++ = LIMIT(g+y1);\
*rgb++ = LIMIT(r+y1);

#elif BITSPP == 16
#define WRITERGB(rgb)\
*(short int*)rgb = ((LIMIT(r+y) & 0xf8) << 8) | ((LIMIT(g+y) & 0xfc) << 3) | (LIMIT(b+y) >> 3);\
rgb += 2;\
*(short int*)rgb = ((LIMIT(r+y1)& 0xf8) << 8) | ((LIMIT(g+y1)& 0xfc) << 3) | (LIMIT(b+y1)>> 3);\
rgb += 2;

#elif BITSPP == 15
#define WRITERGB(rgb)\
*(short int*)rgb = ((LIMIT(r+y) & 0xf8) << 7) | ((LIMIT(g+y) & 0xf8) << 2) | (LIMIT(b+y) >> 3);\
rgb += 2;\
*(short int*)rgb = ((LIMIT(r+y1)& 0xf8) << 7) | ((LIMIT(g+y1)& 0xf8) << 2) | (LIMIT(b+y1)>> 3);\
rgb += 2;

#else
#stop illegal BITSPP
#endif

#define LIMIT(x) ((((x)>0xffffff)?0xff0000:(((x)<=0xffff)?0:(x)&0xff0000))>>16)
{
int ll = ibuf[0] | (ibuf[1] << 8);
unsigned char *origobuf = obuf;
int origsize = size;

ibuf += 2;
while (size > 0)
	{
	size -= (ll+1);
	while (ll > 1)
		{

#ifdef S_COMPRESSED
		if (!(*ibuf & 1))
			{
#endif
			{
			int y, u, v, y1, r, g, b;

#ifdef SAVEFRAMES
			memcpy(yuvbufptr,ibuf,4);
			yuvbufptr += 4;
#endif
			MAKERGB(ibuf);
			WRITERGB(obuf);
			};
			ll -= 4;

#ifdef S_COMPRESSED
			}
		else	{
#if BITSPP == 32
			obuf += ((*ibuf >> 1) << 2);	//4 bytes per pixel
#elif BITSPP == 24
			obuf += ((*ibuf >> 1) * 3);	//3 bytes per pixel
#elif ((BITSPP == 16) || (BITSPP == 15))
			obuf += ((*ibuf >> 1) << 1);  //2 bytes per pixel
#else
#error illegal BITSPP
#endif

#ifdef SAVEFRAMES
			yuvbufptr += ((*ibuf >> 1) << 1);
#endif
			ibuf++; //skip over compression interval
			ll--;
			}; 
#endif

		};

	if (ll == 1)
		{
		if (*ibuf != EOL)
			{
			fprintf(stderr,\
			"EOL not found giving up after %d/%d bytes\n",obuf-origobuf,origsize);
			return 0;
			};

		ibuf++; //skip over EOL

		if (	(ibuf[0] == EOI) && (ibuf[1] == EOI) &&
			(ibuf[2] == EOI) && (ibuf[3] == EOI)) break;

		ll = ibuf[0] | (ibuf[1] << 8);
		ibuf += 2; //skip over line length
		}
	else	{
		fprintf(stderr,\
		"convert(): line length was not 1 but %d after %d/%d bytes\n",\
		ll, obuf - origobuf, origsize);
		return 0;
		};
	};
return obuf-origobuf;
};

#undef LIMIT
#undef MAKERGB
#undef WRITERGB

